local pt  = false
local function OpenDebugScreen()
    if not pt then
        pt = true
        print()
    end
end

-- Do not change Anything here
-- Runtime Variables Start
local UpdateTime     = 0
local FilledAQ       = false
local CleanAQ        = false
local DrainAQ        = false
local ImageIndex     = 0
local FilledANI      = 0
-- Runtime Variables END




function Create()
    this.IsFilled  = false
    this.LastClean = 0
    
end

function Update(timePassed)
    -- OpenDebugScreen()
    UpdateTime = UpdateTime + tonumber(timePassed)
    

    if UpdateTime <= 1 then 
        return 
    end
    -- Game.DebugOut(tostring(this.IsFilled).." - "..tostring(this.LastClean).." - "..tostring(FilledAQ)..' - '..tostring(CleanAQ)..' - '..tostring(DrainAQ)..' - '..ImageIndex)
    
    UpdateTime = 0

    PerformTick()
end


function PerformTick()
    if CheckIsClean()  then
        CheckFill()
    end
    
    PerformDraw()
end

function PerformDraw()
    if not this.IsFilled then
        Object.SetProperty("SubType", 0);
    elseif FilledANI < 2*3 then
        FilledANI = FilledANI +1
        if FilledANI % 3 == 0  then
            Object.SetProperty("SubType", 1 + math.floor(FilledANI/3));
        end
    else
        ImageIndex = (ImageIndex + 1) % 3
        Object.SetProperty("SubType", 4 + ImageIndex);
    end
end



function CheckFill()
    if not this.IsFilled  then
        if not FilledAQ then
            FilledAQ = true
            Object.CreateJob("FillFountain");
            this.Tooltip = "tooltip_animatedfountain_fill"
        end
        return false
    end
    this.Tooltip = "tooltip_animatedfountain_ok"
    return true
end

function CheckCleanTimeOut()
    return this.LastClean + 1440*4 < Game.Time()
end

function CheckIsClean() 
    if CheckCleanTimeOut() then
        if this.IsFilled and not DrainAQ then
            DrainAQ = true
            CleanAQ = false
            Object.CreateJob("DrainFountain");
            this.Tooltip = "tooltip_animatedfountain_drain"
        elseif not(this.IsFilled or CleanAQ) then
            CleanAQ = true
            Object.CreateJob("CleanFountain");
            this.Tooltip = "tooltip_animatedfountain_clean"
        end
        return false
    end
    return true
end


function JobComplete_DrainFountain()
    this.IsFilled = false
end

function JobComplete_FillFountain()
    FilledAQ      = false
    FilledANI     = 0
    this.IsFilled = true
end

function JobComplete_CleanFountain()
    CleanAQ        = false
    this.IsFilled  = false
    this.LastClean = Game.Time()
end


    